;-*- Mode: Common-lisp; Package: optop; Readtable: ytools; -*-
(in-package :optop)

(defun wait-thread (plan procterm negterm g29581)
       (declare (type Env g29581)) (declare (ignore g29581))
       (lambda (then) (declare (type (function (Exec-state-struct t) t) then))
           (lambda (es stack) (declare (type Exec-state-struct es))
               (cond ((eq (the symbol (Exec-state-struct-mode es))
                          (the symbol ':real))
                      (error "wait-thread broken~%Get real"))
                     (t
                      (let ((sit (the opt::Situation (Exec-state-sit-acc es)))
                            (past-sits
                             (the list
                                  (mapcar #'(lambda
                                             (g29582)
                                             (the
                                              opt::Situation
                                              (Exec-state-sit-acc g29582)))
                                          (the
                                           list
                                           (Exec-state-struct-hist es))))))
                        (declare (type opt::Situation sit)
                                 (type list past-sits))
                        (let ((succ-sit false)
                              (failed false)
                              (forced false)
                              (open-subgoal false)
                              (adds nil)
                              (dels nil)
                              (al nil)
                              (dl nil)
                              (elapsed 0.0)
                              (prev-sit
                               (and (not (null past-sits))
                                    (the opt::Situation (car past-sits))))
                              (frac 0.0)
                              (dom
                               (the Optop-domain (Exec-state-dom-acc es))))
                          (declare (type list adds) (type list dels)
                                   (type list al) (type list dl)
                                   (type (or single-float symbol) elapsed)
                                   (type single-float frac)
                                   (type Optop-domain dom))
                          (let-fun nil
                                   (cond ((process-find procterm sit)
                                          (project-found-process))
                                         (t (project-forced-process)))
                                   (compute-elapsed-time)
                                   (let ((new-es
                                          (the
                                           Exec-state-struct
                                           (note-post-process-changes))))
                                     (declare (type Exec-state-struct new-es))
                                     (values (the
                                              symbol
                                              (the
                                               symbol
                                               (cond
                                                ((or forced open-subgoal)
                                                 (the
                                                  symbol
                                                  (cond
                                                   ((null
                                                     (the
                                                      list
                                                      (Exec-state-struct-active
                                                       new-es)))
                                                    (the
                                                     symbol
                                                     (cond
                                                      (open-subgoal
                                                       (the
                                                        symbol
                                                        ':continuing))
                                                      (t
                                                       (the
                                                        symbol
                                                        ':blocked)))))
                                                   (t
                                                    (the
                                                     symbol
                                                     ':continuing)))))
                                                (failed (the symbol ':failed))
                                                (t
                                                 (the symbol ':continuing)))))
                                             new-es))
                                   :where
                                   (project-found-process nil
                                    (multiple-value-setq (succ-sit
                                                          adds
                                                          dels
                                                          elapsed
                                                          frac)
                                      (process-project-and-record
                                       sit
                                       (the
                                        opt::Situation
                                        (Exec-state-sit-acc es))
                                       prev-sit
                                       procterm
                                       negterm
                                       (the
                                        Situation-space-struct
                                        (Exec-state-struct-sit-space es))
                                       dom))
                                    (let* ()
                                      (let
                                       ((g29583
                                         (or
                                          (not succ-sit)
                                          (let
                                           ((new-pc
                                             (Situation-processes-acc
                                              succ-sit)))
                                           (and
                                            new-pc
                                            (not
                                             (Process-complex-struct-kosher
                                              new-pc)))))))
                                       (setq failed g29583))))
                                   (project-forced-process nil
                                    (let* ()
                                      (let
                                       ((g29586 true))
                                       (setq failed g29586)))
                                    (case (the
                                           symbol
                                           (Exec-state-struct-mode es))
                                      (:forced
                                       (multiple-value-setq
                                        (succ-sit al dl)
                                        (process-existence-force
                                         plan
                                         procterm
                                         negterm
                                         sit
                                         past-sits
                                         (the
                                          Situation-space-struct
                                          (Exec-state-struct-sit-space es))
                                         dom))
                                       (cond
                                        ((not
                                          (process-find procterm succ-sit))
                                         (dbg-save
                                          :run-loud
                                          (procterm procterm Sexp)
                                          (sit sit Situation)
                                          (succ-sit succ-sit (~ Situation))
                                          (dom dom Domain))
                                         (error
                                          "wait-thread broken~%~s"
                                          (make-Printable
                                           (lambda
                                            (ytools::srm)
                                            (out
                                             (:to ytools::srm)
                                             "Process cannot be forced to"
                                             " exist: "
                                             procterm))))))
                                       (multiple-value-setq
                                        (succ-sit adds dels elapsed frac)
                                        (process-project-and-record
                                         succ-sit
                                         (the
                                          opt::Situation
                                          (Exec-state-sit-acc es))
                                         prev-sit
                                         procterm
                                         negterm
                                         (the
                                          Situation-space-struct
                                          (Exec-state-struct-sit-space es))
                                         dom))
                                       (multiple-value-setq
                                        (adds dels)
                                        (add-del-combine al dl adds dels))
                                       (let*
                                        ()
                                        (let
                                         ((g29584 true))
                                         (setq forced g29584))))
                                      (:zero-step
                                       (let*
                                        ()
                                        (let
                                         ((g29585
                                           (excl::bq-list
                                            (the symbol 'process-exists)
                                            procterm
                                            negterm)))
                                         (setq open-subgoal g29585))))))
                                   (compute-elapsed-time nil
                                    (the single-float
                                         (cond
                                          ((and
                                            forced
                                            (not
                                             (eq
                                              elapsed
                                              (the symbol '*never)))
                                            (> frac 0.0)
                                            (< frac 1.0))
                                           (the
                                            single-float
                                            (let*
                                             ()
                                             (let
                                              ((g29587
                                                (the
                                                 single-float
                                                 (the
                                                  single-float
                                                  (/
                                                   (the single-float elapsed)
                                                   frac)))))
                                              (setq elapsed g29587))))))))
                                   (note-post-process-changes nil
                                    (the Exec-state-struct
                                         (let
                                          ((elapsed-time
                                            (the
                                             single-float
                                             (cond
                                              ((eq
                                                elapsed
                                                (the symbol '*never))
                                               (the
                                                single-float
                                                (exec-value-get
                                                 max-time-link*
                                                 (the
                                                  list
                                                  (Exec-state-struct-vals
                                                   es)))))
                                              (t
                                               (the single-float elapsed)))))
                                           (new-thread
                                            (the
                                             Thread-struct
                                             (new-Thread
                                              then
                                              (excl::bq-list
                                               (the symbol 'after)
                                               plan)
                                              stack))))
                                          (declare
                                           (type single-float elapsed-time)
                                           (type Thread-struct new-thread))
                                          (the
                                           Exec-state-struct
                                           (make-inst
                                            Exec-state-struct
                                            :vals
                                            (the
                                             list
                                             (exec-value-set
                                              forcings-link*
                                              (the
                                               list
                                               (Exec-state-struct-vals es))
                                              (lambda (fc) (the number (+ fc 1)))
                                              false))
                                            :active
                                            (the
                                             list
                                             (cond
                                              ((or
                                                (and failed (not forced))
                                                open-subgoal)
                                               (the
                                                list
                                                (Exec-state-struct-active
                                                 es)))
                                              (t
                                               (the
                                                list
                                                (cons
                                                 new-thread
                                                 (the
                                                  list
                                                  (Exec-state-struct-active
                                                   es)))))))
                                            :pp
                                            (the
                                             Plan-prefix-struct
                                             (make-Plan-prefix
                                              (the
                                               fixnum
                                               (+
                                                (the
                                                 fixnum
                                                 (Plan-prefix-struct-length
                                                  (the
                                                   Plan-prefix-struct
                                                   (Exec-state-struct-pp
                                                    es))))
                                                1))
                                              (the
                                               single-float
                                               (+
                                                (the
                                                 single-float
                                                 (Plan-prefix-struct-duration
                                                  (the
                                                   Plan-prefix-struct
                                                   (Exec-state-struct-pp
                                                    es))))
                                                elapsed-time))
                                              (the
                                               opt::Situation
                                               (or succ-sit sit))
                                              (the
                                               Plan-prefix-delta-struct
                                               (make-Plan-prefix-delta-struct
                                                (the
                                                 opt::Uterm
                                                 (uniquify-action plan dom))
                                                0
                                                elapsed-time
                                                (the null 'nil)
                                                (the
                                                 Plan-prefix-struct
                                                 (Exec-state-struct-pp
                                                  es))))))
                                            :hist
                                            (the
                                             list
                                             (cons
                                              es
                                              (the
                                               list
                                               (Exec-state-struct-hist es))))
                                            :blocked
                                            (the
                                             list
                                             (cond
                                              (open-subgoal
                                               (the
                                                list
                                                (cons
                                                 (the
                                                  Blockage-struct
                                                  (make-Blockage-struct
                                                   (the
                                                    Gate-class
                                                    (make-Gate-class
                                                     (the
                                                      symbol
                                                      ':open-subgoals)
                                                     (the
                                                      list
                                                      (list
                                                       (the
                                                        list
                                                        (list
                                                         open-subgoal))))))
                                                   (the
                                                    list
                                                    (list new-thread))))
                                                 (the
                                                  list
                                                  (Exec-state-struct-blocked
                                                   es)))))
                                              (t
                                               (the
                                                list
                                                (Exec-state-struct-blocked
                                                 es)))))
                                            :mode
                                            (Exec-state-struct-mode es)
                                            :steps
                                            (Exec-state-struct-steps es)
                                            :elapsed
                                            (Exec-state-struct-elapsed es)
                                            :sit-space
                                            (Exec-state-struct-sit-space es)
                                            :bdgs
                                            (Exec-state-struct-bdgs
                                             es))))))))))))))