(defun next-red (dir)
   (interactive "P")
   (cond (dir
	  (re-search-backward  "\n *[0-9]*>")))
   (re-search-forward "\n *[0-9]*>"))

(defun next-at-this-indentation (dir)
   (interactive "P")
   (let ((found nil)
	 (keep-going t)
	 (start (point))
	 (col (current-column)))
      (while (and keep-going (not found))
	 (cond ((= (forward-line (cond (dir -1) (t 1)))
		   0)
		(back-to-indentation)
		(cond ((= (current-column) col)
		       (setq found t))))
	       (t (setq keep-going nil))))
      (cond ((not found)
	     (goto-char start)
	     (message "Not found")))))
	  