;-*- Mode: Common-lisp; Package: optop; Readtable: ytools; -*-
(in-package :optop)

(depends-on %module/ nisp)

;; This should all be moved elsewhere.

(depends-on :at-compile-time %optop/ lisp-nisp-ty)

(depends-on :at-run-time %hacks/ dagprint)

(lisp-class-as-nisp-type DAG-struct-spec
      (:package :ytools)
   (:conser (chl - (Fun (Lst Obj) (Obj))) (ytools::make-DAG-struct-spec chl))
   (children - (Fun (Lst Obj) (Obj))))

(lisp-class-as-nisp-type Printable-DAG-node
       (:package :ytools)
    (id - Obj)
    (node - Obj)
    (as-printed - Printable-DAG-node)
    (height - (~ Fixnum))
    (ancestor - (~ Printable-DAG-node))
    (cycle - Integer)
    (children - (Lst Printable-DAG-node))
    (parents - (Lst Printable-DAG-node))
    (ancestors - (Lst Printable-DAG-node)))

(lisp-class-as-nisp-type DAG-print-spec
       (:package :ytools)
    (direct-printer - (Fun Void (Printable-DAG-node) true))
    (down-printer - (Fun Void (Printable-DAG-node) true))
    (up-printer - (Fun Void (Printable-DAG-node (Lst Printable-DAG-node))
		            true))
    (cycle-printer - (Fun Void (Printable-DAG-node) true))
    (indent-printer - (Fun Fixnum (Fixnum) true)))

(specdecl dag-print - (Fun Void ((Lst Obj) DAG-struct-spec DAG-print-spec) true)
	  node-indent-dot-printer - (Fun Fixnum (Fixnum) true))
