;-*- Mode: Common-lisp; Package: optop; Readtable: ytools; -*-
(in-package :optop)

(depends-on %module/ nisp)

(depends-on %ytools/ debug)

(opt-load %optop/ ferry)

(!= plan-dbg-amt* 0)

(test "Ferry"
   (decl ()
      (let ((solns (nth-value 0 (search-for-plan 'test-ferry)))
	    (expected '((board c1 a) (sail a b) (debark c1 b))))
	 (let ((found (<# !_act (reverse (!_acts (!_plan (car solns)))))))
	    (check
	       (and (not (null solns))
		    (equal found expected))
	     :else
		(:q ((null solns)
		     "No solutions found")
		    (t
		     "Didn't find expected solution " expected
		     :% " Found: " found :%)))))))

