import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.border.*;

public class Remote 
{
  JFrame chat_frame, lisp_frame, text_frame, graphics_frame;
  JPanel chat_panel;
  JScrollPane chat_area_scroll;
  JTextArea chat_area;
  JTextField chat_entry;
  static Remote the_remote;
  static AttributeSet atset;

  public Remote()
  {
    chat_frame = new JFrame("Chat");
    chat_frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    chat_panel = (JPanel) chat_frame.getContentPane();
    chat_panel.setLayout(new BorderLayout());
    chat_area = new JTextArea(new PlainDocument(), null, 20, 80);
    chat_area.setBorder(new EmptyBorder(3,3,3,3));
    chat_area_scroll = new JScrollPane(chat_area);
    chat_entry = new JTextField();
    chat_entry.addActionListener(new Chat_entry_listener(chat_entry, chat_area));
    chat_panel.add(chat_area_scroll, BorderLayout.CENTER);
    chat_panel.add(chat_entry, BorderLayout.SOUTH);
    chat_frame.pack();
  }
    
  public static void main(String[] argv)
  {
    String[] avail_fams =
             GraphicsEnvironment.getLocalGraphicsEnvironment()
	     .getAvailableFontFamilyNames();
    for (int i=0;i<avail_fams.length;i++)
      {
	System.out.println(avail_fams[i]);
      }
    atset = (StyleContext.getDefaultStyleContext())
            .addAttribute(SimpleAttributeSet.EMPTY,
			  StyleConstants.FontFamily,
			  "Monospaced");
    the_remote = new Remote();
    the_remote.chat_frame.setVisible(true);
  }

  // Listens to chat_entry events, i.e., carriage returns.
  static class Chat_entry_listener implements ActionListener
  {

    JTextField chat_entry;
    JTextArea chat_area;

    public Chat_entry_listener(JTextField chat_entry, JTextArea chat_area)
    {
      super();
      this.chat_entry = chat_entry;
      this.chat_area = chat_area;
    }


    public void actionPerformed(ActionEvent e)
      {
	chat_area.append("\n" + chat_entry.getText());
	chat_entry.setText("");
// 	Document edoc = (PlainDocument)(chat_area.getDocument());
// 	edoc.insertString(edoc.getLength(), chat_field.getText(), atset);
      }
  }
	
}
