;-*- Mode: Common-lisp; Package: optop; Readtable: ytools; -*-
(in-package :optop)
;;;$Id: mmgraph.lisp,v 1.2 2005/08/27 05:30:41 dvm Exp $

(depends-on %module/ nisp)

(defnisptype Maxmatch-goal-tree :forward)

(defnisptype Maxmatch-tree
   (Structure action-vars other-vars - (Lst Qvar)
	      subtrees - (Lst Maxmatch-goal-tree)))


(defnisptype Maxmatch-goal-tree
    achievable - Boolean 
    goal - Sexp   ;; perhaps better: list of remaining goals,
                  ;; where the first is the one we split on
    included excluded - Maxmatch-tree)
    
(deffunc maximal-matches - (Lst Maximal-match) 
                         (conj constraints - (Lst Sexp)
			  vid - Varid env - Bdgenv
			  sit - Situation th - Domain)
   (