STUFF SALVAGED from execute.lisp that may go back there or to optexec.lisp

(deffunc cached-thread-result - (Mlv (~ Exec-status) Exec-state Action)
	                      (es - Exec-state act - Sexp newth - Thread
			       dom - Domain)
   (let ((uact (uniquify-action act dom)))
      (let ((pr (recover-cached-transition
		    (!_mode es) (!_sit es) uact (!_sit-space es))))
	 (cond (pr
		(multi-let (((status new-es)
			     (projected-thread-result pr es newth)))
		   (values status new-es uact)))
	       (t
		(values false es uact))))))



(deffunc projected-thread-result - (Mlv Exec-status Exec-state)
                             (pr - Projection-result es - Exec-state
			      newth - Thread)
   (with es
      (match-cond pr
	 (:? :failed
	    (values ':failed es))
	 (:? ?(:\| (?(:& :okay ?stat)
		    ?new-sit ?elapsed ?numsteps)
		   (?(:& :forced ?stat)
		    ?num-forcings ?new-sit ?elapsed ?numsteps))
	    (continue-exec
	      (copy-with-changes Exec-state
		 (:vals
		    (cond ((eq stat ':forced)
			   (exec-value-set
			       penalty-link* !>link-vals
			       (\\ (p) (+ p num-forcings))
			       false))
			  (t !>link-vals))
		 :steps (+ !>steps numsteps)
		 :elapsed (be Time-int
			      (+ (be Time-int !>elapsed)
				 elapsed))
		 :active (cons newth !>active)
		 :pp (place-Plan-prefix
			!>pp numsteps elapsed
			
			   (+ !>duration elapsed)
			   (be Situation new-sit)
			   (make Plan-prefix-delta

	                  (pp - Plan-prefix 
			   delta-step - (Const 0 1) elapsed - Time-int
			   act - Action
			   linkid - (~ Symbol)
			   assumptions - (Lst Sexp)
			   succ init-sit - Situation
			   sit-space - Situation-space dom - Domain)

			       
		 :sit-space !>sit-space
		 :hist (cons es !>hist)
		 :link-vals !>link-vals
		 :link-bdgs !>link-bdgs
		 :blocked !>blocked)))
	 (:? ?(:\| :ready
		   (:open-subgoals ?dnf))
	    (values (cond ((null !>active) ':blocked)
			  (t ':continuing))
	       (make-inst Exec-state
		  :mode !>mode :forcings !>forcings 
		  :steps !>steps :elapsed !>elapsed
		  :active !>active
		  :sit !>sit
		  :sit-space !>sit-space
		  :hist (cons es !>hist)
		  :link-bdgs !>link-bdgs
		  :link-vals !>link-vals
		  :blocked 
		      (cons (make Blockage
			       (make Gate ':open-subgoals dnf)
			       (list newth))
			    !>blocked))))
	 (:? :failed
	    (values ':failed es))
	 (t
	  (signal-problem projected-thread-result
	     "Unintelligible projection result " pr)))))
