;-*- Mode: Common-lisp; Package: optop; Readtable: ytools; -*-
(in-package :optop)

(end-header :no-compile)

;;; (ext:saveinitmem "~/ipc.mem" :init-function 'try-one-prob-and-exit)
;;; Then call clisp -norc -m 9M -M ~/ipc.mem



(defun local-reset ()
   (!= *random-state*
       (with-open-file (rsrm "~/randomstate" :direction ':input)
	  (read rsrm))))

(!= opt::pddl2.1-compatible* true)
;;;;(!= optop::reuse-rmgraphs* false)
;;;;(!= reduction-dbg* true)

(shadow 'opt::CON :optop)

(def-ytools-logical-pathname domains "/home/ipc4/DOMAINS/")

(def-ytools-logical-pathname airport
    "%DOMAINS/airport/temporal-timewindows/adl-temporal-timedliterals/")

(def-ytools-logical-pathname pipesworld
    "%DOMAINS/pipesworld/tankage-temporal/strips-temporal/")

(def-ytools-logical-pathname promela-optel 
    "%DOMAINS/promela/optical-telegraph-fluents-derivedpredicates/adl-fluents-derivedpredicates/")

(def-ytools-logical-pathname promela-phil 
    "%DOMAINS/promela/philosophers-fluents-derivedpredicates/adl-fluents-derivedpredicates/")

(def-ytools-logical-pathname psr "%DOMAINS/psr/large/adl-derivedpredicates/")

(def-ytools-logical-pathname satellite
    "%DOMAINS/satellite/Complex-timewindows/strips-fluents-temporal-timedliterals/")

(def-ytools-logical-pathname settlers "%DOMAINS/settlers/strips-fluents/")

(repeat :for ((lpn :in '(airport pipesworld promela-optel promela-phil
			 psr satellite settlers)))
   (yt::declare-pathname-associate
       'opt::checked
       (yt::lookup-ytools-logical-pathname lpn)
       (ensure-directories-exist
	  (merge-pathnames
	     (make-Pathname
		:directory
		   `(:relative ,(string-downcase (symbol-name lpn))))
	     "~/chk/"))
       "chk"))
